## ros-humble-rplidar-ros 2.1.4

=== CMakeLists.txt ===
################################################################################
# Set minimum required version of cmake, project name and compile options
################################################################################
cmake_minimum_required(VERSION 3.5)
project(rplidar_ros)

if(NOT CMAKE_CXX_STANDARD)
  set(CMAKE_CXX_STANDARD 14)
endif()

if(CMAKE_COMPILER_IS_GNUCXX OR CMAKE_CXX_COMPILER_ID MATCHES "Clang")
  add_compile_options(-Wall -Wextra -Wpedantic)
endif()

if(MSVC)
  add_compile_definitions(
    _USE_MATH_DEFINES
  )
endif()

set(RPLIDAR_SDK_PATH "./sdk/")

if(APPLE)
add_compile_definitions(_MACOS)
FILE(GLOB RPLIDAR_SDK_SRC
  "${RPLIDAR_SDK_PATH}/src/arch/macOS/*.cpp"
  "${RPLIDAR_SDK_PATH}/src/hal/*.cpp"
  "${RPLIDAR_SDK_PATH}/src/*.cpp"
)
else()
FILE(GLOB RPLIDAR_SDK_SRC 
  "${RPLIDAR_SDK_PATH}/src/arch/linux/*.cpp"
  "${RPLIDAR_SDK_PATH}/src/hal/*.cpp"
  "${RPLIDAR_SDK_PATH}/src/*.cpp"
)
endif()

################################################################################
# Find ament packages and libraries for ament and system dependencies
################################################################################
find_package(ament_cmake REQUIRED)
find_package(rclcpp REQUIRED)
find_package(sensor_msgs REQUIRED)
find_package(std_srvs REQUIRED)

################################################################################
# Build
################################################################################
include_directories(
  ${RPLIDAR_SDK_PATH}/include
  ${RPLIDAR_SDK_PATH}/src
  ${Boost_INCLUDE_DIRS}
)

add_executable(rplidar_node	src/rplidar_node.cpp ${RPLIDAR_SDK_SRC})
# target_link_libraries(rplidar_node ${ament_cmake_LIBRARIES})
ament_target_dependencies(rplidar_node
  rclcpp
  std_srvs
  sensor_msgs
)

add_executable(rplidar_composition src/rplidar_node.cpp ${RPLIDAR_SDK_SRC})
ament_target_dependencies(rplidar_composition
  rclcpp
  std_srvs
  sensor_msgs
)

add_executable(rplidar_client src/rplidar_client.cpp)
ament_target_dependencies(rplidar_client
  rclcpp
  std_srvs
  sensor_msgs
)
################################################################################
# Install
################################################################################
install(DIRECTORY launch rviz
  DESTINATION share/${PROJECT_NAME}
)

install(
  TARGETS rplidar_node rplidar_composition rplidar_client
  RUNTIME DESTINATION lib/${PROJECT_NAME}
)

################################################################################
# Macro for ament package
################################################################################
ament_export_dependencies(rclcpp)
ament_export_dependencies(std_msgs)
ament_export_dependencies(sensor_msgs)
ament_export_include_directories(include)
ament_package()

=== sdk/Makefile ===
#/*
# *  RPLIDAR SDK
# *
# *  Copyright (c) 2009 - 2014 RoboPeak Team
# *  http://www.robopeak.com
# *  Copyright (c) 2014 - 2019 Shanghai Slamtec Co., Ltd.
# *  http://www.slamtec.com
# *
# */
#/*
# * Redistribution and use in source and binary forms, with or without
# * modification, are permitted provided that the following conditions are met:
# *
# * 1. Redistributions of source code must retain the above copyright notice,
# *    this list of conditions and the following disclaimer.
# *
# * 2. Redistributions in binary form must reproduce the above copyright notice,
# *    this list of conditions and the following disclaimer in the documentation
# *    and/or other materials provided with the distribution.
# *
# * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
# * AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO,
# * THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
# * PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR
# * CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
# * EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
# * PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS;
# * OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,
# * WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR
# * OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE,
# * EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
# *
# */
#
HOME_TREE := ../

MODULE_NAME := $(notdir $(CURDIR))

include $(HOME_TREE)/mak_def.inc

CXXSRC += src/sl_lidar_driver.cpp \
          src/hal/thread.cpp\
          src/sl_crc.cpp\
	      src/sl_serial_channel.cpp\
	      src/sl_tcp_channel.cpp\
	      src/sl_udp_channel.cpp

C_INCLUDES += -I$(CURDIR)/include -I$(CURDIR)/src

ifeq ($(BUILD_TARGET_PLATFORM),Linux)
CXXSRC += src/arch/linux/net_serial.cpp \
          src/arch/linux/net_socket.cpp \
          src/arch/linux/timer.cpp 
endif


ifeq ($(BUILD_TARGET_PLATFORM),Darwin)
CXXSRC += src/arch/macOS/net_serial.cpp \
          src/arch/macOS/net_socket.cpp \
          src/arch/macOS/timer.cpp
endif

all: build_sdk

include $(HOME_TREE)/mak_common.inc

clean: clean_sdk

=== debian/changelog ===
ros-humble-rplidar-ros (2.1.4-1jammy) jammy; urgency=high

  * Update SDK.
    * UltraDense protocol support
    * support for stoppping A1 motor
    * Optimize lidar driver for switching S2E workingmode
  * Bugfix:logical error
  * Install udev rules via debian.
  * Contributors: Tony Baltovski, deyou wang

 -- Wang DeYou <deyou.wang@slamtec.com>  Mon, 14 Aug 2023 16:00:00 -0000

ros-humble-rplidar-ros (2.1.3-1jammy) jammy; urgency=high

  * Bugfix:auto standby mode not work
  * Rename SLLidar* to RPLidar* in rplidar_node.cpp
  * Renaming variable m_running to is_scanning
  * Update README
  * Use rplidar_ros.rviz instead of rplidar.rviz
  * Update source files in src directory:
    Use the source files developed by Slamtec instead of the old ones, and add the functionality of the old code.
  * Modify and add launch files
  * Update rplidar-sdk to 2.0.0
  * Update create_udev_rules.sh
  * Update description in package.xml
  * Update maintainer to Wang DeYou
  * Contributors: Wang DeYou

 -- Wang DeYou <deyou.wang@slamtec.com>  Wed, 19 Jul 2023 16:00:00 -0000

ros-humble-rplidar-ros (2.1.0-1jammy) jammy; urgency=high

  * Add auto standby mode (#29 <https://github.com/allenh1/rplidar_ros/issues/29>)
    * Add auto standby mode
    Turn on/off motor based on topic subsribers
    * Set auto_standby off by default
  * Fix building on Apple machines (#30 <https://github.com/allenh1/rplidar_ros/issues/30>)
  * Update README & fix launch files for Foxy and up (#26 <https://github.com/allenh1/rplidar_ros/issues/26>)
    * Update README.md
    based on modifications from youngday
    * Update launch files for Foxy or later
  * Contributors: Jesse Zhang, Vasily Kiniv

 -- Wang DeYou <deyou.wang@slamtec.com>  Mon, 05 Sep 2022 16:00:00 -0000

ros-humble-rplidar-ros (2.0.3-1jammy) jammy; urgency=high

  * Fix build with later versions of GCC
  * Contributors: Hunter L. Allen

 -- Wang DeYou <deyou.wang@slamtec.com>  Wed, 31 Aug 2022 16:00:00 -0000

ros-humble-rplidar-ros (2.0.2-1jammy) jammy; urgency=high

  * Remove test_rplidar.launch.py, since relevant executables no longer exist (#24 <https://github.com/allenh1/rplidar_ros/issues/24>)
  * Contributors: Hunter L. Allen

 -- Wang DeYou <deyou.wang@slamtec.com>  Wed, 26 May 2021 16:00:00 -0000

ros-humble-rplidar-ros (2.0.1-1jammy) jammy; urgency=high

  * Remove old driver (#21 <https://github.com/allenh1/rplidar_ros/issues/21>)
    * Remove old rplidar driver in favor of the component version
    * Lint the source
  * Fix incompatibilities with slam_toolbox (#20 <https://github.com/allenh1/rplidar_ros/issues/20>)
    * Fix incompatibilities with slam_toolbox:
    - Fix angle compensate mode to publish angle compensated values
    - Fix angle_increment calculation
    - Add optional flip_x_axis option to deal with issue discussed here: https://github.com/SteveMacenski/slam_toolbox/issues/198.  Flip x-axis can be used when laser is mounted with motor behind it as rotated TF laser frame doesn't seem to work with slam_toolbox.
    * Fix whitespace
  * Fix node count for component implementation (#19 <https://github.com/allenh1/rplidar_ros/issues/19>)
  * Slam Toolbox compatibility (#18 <https://github.com/allenh1/rplidar_ros/issues/18>)
    (cherry picked from commit f21079fea8eca8946b5b4ae72f50b8d9f1ac46a2)
  * Fix building with GCC 10 (#17 <https://github.com/allenh1/rplidar_ros/issues/17>)
  * Contributors: Christen Lofland, Hunter L. Allen, justinIRBT

 -- Wang DeYou <deyou.wang@slamtec.com>  Sat, 12 Sep 2020 16:00:00 -0000

ros-humble-rplidar-ros (2.0.0-1jammy) jammy; urgency=high

  * Update SDK to Version 0.12.0 (#14 <https://github.com/allenh1/rplidar_ros/issues/14>)
    * Register the rclcpp component
    * Update RPLIDAR SDK to version 1.12.0
  * Update ROS 2 parameters and use node's clock instance (#9 <https://github.com/allenh1/rplidar_ros/issues/9>)
    * Update ROS 2 parameters and use node's clock instance
    * Fix scan_mode listing output
    * Stop motors and exit when set_scan_mode() call fails
  * Fix compilation with eloquent (#6 <https://github.com/allenh1/rplidar_ros/issues/6>)
  * Use Composition node with launch files (#4 <https://github.com/allenh1/rplidar_ros/issues/4>)
  * Composable nodes (#3 <https://github.com/allenh1/rplidar_ros/issues/3>)
    * Begin implementation of composable rplidar_ros::rplidar_node
    * Declare composition node library in CMake, as well as continue the port
    * Get to a compiling state
    * Add start/stop motor callbacks + more driver setup
    * Add publish loop for scans
    * Add composition node
    * Lint
  * Port rviz and launch files to ROS2 (#2 <https://github.com/allenh1/rplidar_ros/issues/2>)
    * Port non-rviz launch files to ROS2
    * Compatibility with rviz2
    * revert whitespace changes
    * Port the remaining launch files to ROS2
    * Revert more whitespace changes
    * Fix luanch and rviz install path indent level
  * Ros2 port (#1 <https://github.com/allenh1/rplidar_ros/issues/1>)
    ROS 2 port
    * Port CMakeLists.txt
    * Port package.xml
    * Port client.cpp
    * Port node.cpp
    Fix compilation
  * Support TCP
  * upgrade sdk 1.10.0
  * upgrade sdk 1.9.0
    [new feature] support baudrate 57600 and 1382400, support HQ scan response
    [bugfix] TCP channel doesn't work
    [improvement] Print warning messages when deprecated APIs are called; imporve angular accuracy for ultra capsuled scan points
  * [bugfix]modify scan_mode at test_rplidar.launch and test_rplidar_a3.launch
  * Contributors: Dan Rose, Hunter L. Allen, WubinXia, kint

 -- Wang DeYou <deyou.wang@slamtec.com>  Tue, 14 Jul 2020 16:00:00 -0000

ros-humble-rplidar-ros (1.10.0-1jammy) jammy; urgency=high

  * Update RPLIDAR SDK to 1.10.0
  * [new feature] support Rplidar S1
  * Contributors: tony,WubinXia

 -- Wang DeYou <deyou.wang@slamtec.com>  Thu, 21 Feb 2019 16:00:00 -0000

ros-humble-rplidar-ros (1.9.0-1jammy) jammy; urgency=high

  * Update RPLIDAR SDK to 1.9.0


=== debian/control ===
Source: ros-humble-rplidar-ros
Section: misc
Priority: optional
Maintainer: Wang DeYou <deyou.wang@slamtec.com>
Build-Depends: debhelper (>= 9.0.0), ros-humble-ament-cmake-auto, ros-humble-ament-cmake-ros, ros-humble-rclcpp, ros-humble-rclcpp-components, ros-humble-sensor-msgs, ros-humble-std-srvs, ros-humble-ros-workspace
Homepage: 
Standards-Version: 3.9.2

Package: ros-humble-rplidar-ros
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, ros-humble-rclcpp, ros-humble-rclcpp-components, ros-humble-sensor-msgs, ros-humble-std-srvs, ros-humble-ros-workspace
Description: The rplidar ros package, support rplidar A1/A2/A3/S1/S2/S3/T1

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1
# TODO: remove the LDFLAGS override.  It's here to avoid esoteric problems
# of this sort:
#  https://code.ros.org/trac/ros/ticket/2977
#  https://code.ros.org/trac/ros/ticket/3842
export LDFLAGS=
export PKG_CONFIG_PATH=/opt/ros/humble/lib/pkgconfig
# Explicitly enable -DNDEBUG, see:
# 	https://github.com/ros-infrastructure/bloom/issues/327
export DEB_CXXFLAGS_MAINT_APPEND=-DNDEBUG
ifneq ($(filter nocheck,$(DEB_BUILD_OPTIONS)),)
	BUILD_TESTING_ARG=-DBUILD_TESTING=OFF
endif

DEB_HOST_GNU_TYPE ?= $(shell dpkg-architecture -qDEB_HOST_GNU_TYPE)

%:
	dh $@ -v --buildsystem=cmake --builddirectory=.obj-$(DEB_HOST_GNU_TYPE)

override_dh_auto_configure:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/humble/setup.sh" ]; then . "/opt/ros/humble/setup.sh"; fi && \
	dh_auto_configure -- \
		-DCMAKE_INSTALL_PREFIX="/opt/ros/humble" \
		-DAMENT_PREFIX_PATH="/opt/ros/humble" \
		-DCMAKE_PREFIX_PATH="/opt/ros/humble" \
		$(BUILD_TESTING_ARG)

override_dh_auto_build:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/humble/setup.sh" ]; then . "/opt/ros/humble/setup.sh"; fi && \
	dh_auto_build

override_dh_auto_test:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	echo -- Running tests. Even if one of them fails the build is not canceled.
	if [ -f "/opt/ros/humble/setup.sh" ]; then . "/opt/ros/humble/setup.sh"; fi && \
	dh_auto_test || true

override_dh_shlibdeps:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/humble/setup.sh" ]; then . "/opt/ros/humble/setup.sh"; fi && \
	dh_shlibdeps -l$(CURDIR)/debian/ros-humble-rplidar-ros//opt/ros/humble/lib/

override_dh_auto_install:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/humble/setup.sh" ]; then . "/opt/ros/humble/setup.sh"; fi && \
	dh_auto_install
